from datetime import datetime
from typing import List, Optional, Dict, Any

from janis_core import *
from janis_core.types.common_data_types import String, Boolean, File

Anvi_Get_Codon_Frequencies_V0_1_0 = CommandToolBuilder(tool="anvi_get_codon_frequencies", base_command=["anvi-get-codon-frequencies"], inputs=[ToolInput(tag="in_contigs_db", input_type=String(optional=True), prefix="--contigs-db", doc=InputDocumentation(doc="Anvi'o contigs database generated by 'anvi-gen-\ncontigs'")), ToolInput(tag="in_gene_caller_id", input_type=String(optional=True), prefix="--gene-caller-id", doc=InputDocumentation(doc="OK. You can declare a single gene caller ID if you\nwish, in which case anvi'o would only return results\nfor a single gene call. If you don't declare anything,\nwell, you must be prepared to brace yourself if you\nare working with a very large contigs database with\nhundreds of thousands of genes.")), ToolInput(tag="in_return_aa_frequencies_instead", input_type=Boolean(optional=True), prefix="--return-AA-frequencies-instead", doc=InputDocumentation(doc="By default, anvi'o will return codon frequencies (as\nthe name suggests), but you can ask for amino acid\nfrequencies instead, simply because you always need\nmore data and more stuff. You're lucky this time, but\nis there an end to this? Will you ever be satisfied\nwith what you have? Anvi'o needs answers.")), ToolInput(tag="in_output_file", input_type=File(optional=True), prefix="--output-file", doc=InputDocumentation(doc="File path to store results.")), ToolInput(tag="in_percent_normalize", input_type=Boolean(optional=True), prefix="--percent-normalize", doc=InputDocumentation(doc="Instead of actual counts, report percent-normalized\nfrequencies per gene (because you are too lazy to do\nthings the proper way in R).")), ToolInput(tag="in_mere_ns_codon_normalization", input_type=Boolean(optional=True), prefix="--merens-codon-normalization", doc=InputDocumentation(doc="This is a flag to percent normalize codon frequenies\nwithin those that encode for the same amino acid. It\nis different from the flag --percent-normalize, since\nit does not percent normalize frequencies of codons\nwithin a gene based on all codon frequencies. Clearly\nthis flag is not applicable if you wish to work with\nboring amino acids. WHO WORKS WITH AMINO ACIDS\nANYWAYS.\n"))], outputs=[ToolOutput(tag="out_output_file", output_type=File(optional=True), selector=InputSelector(input_to_select="in_output_file", type_hint=File()), doc=OutputDocumentation(doc="File path to store results."))], container=None, version="v0.1.0")


if __name__ == "__main__":
    # or "cwl"
    Anvi_Get_Codon_Frequencies_V0_1_0().translate("wdl", allow_empty_container=True)

